/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ConstructionActionBarEntry");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ConstructionActionBarEntry");

dojo.require("jazz.core.loader");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorFactory");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.ui.internal.page.ArtifactEditorPageController");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.jrs.Uploader");
 
(function() 
{
	var TestCaseTableView           = com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView;
	var TestScriptTableView         = com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptTableView;
	var ArtifactEditorPageController = com.ibm.rqm.planning.web.ui.internal.page.ArtifactEditorPageController;
	var ArtifactModel               = com.ibm.rqm.planning.web.ui.internal.model.ArtifactModel;	
	var EditorFactory 	   			= com.ibm.rqm.planning.web.ui.internal.util.EditorFactory;
	var TestCaseClient         		= com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
	var TestScriptClient       		= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
	var Constants                   = com.ibm.rqm.planning.web.client.internal.Constants;
	var getAuthenticatedContributor	= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var TestCaseMapper				= com.ibm.rqm.planning.web.client.internal.mapper.TestCaseMapper;
    var PermissionsClient           = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var CommonUtility               = com.ibm.asq.common.web.ui.internal.util.Utility;
	
	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ConstructionActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
			},
	
			postCreate: function(args)
			{
//				this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView", null);
				this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient", null);
				this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper", null);
				setTimeout(dojo.hitch(this,function(){
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.FileSelector",null);
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.AdapterSelector",null)
					this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient",null);
					this._loadClassAsync("com.ibm.rqm.appscan.web.client.internal.ScanClient",null);
					this._loadClassAsync("com.ibm.rqm.appscan.web.client.internal.InfoClient",null);
					this._loadClassAsync("com.ibm.rqm.appscan.web.client.internal.Constants",null);
					this._loadClassAsync("com.ibm.rqm.appscan.web.ui.internal.view.common.ASELink",null);
					this._loadClassAsync("com.ibm.rqm.appscan.web.ui.internal.view.common.ImageCache",null);
					this._loadClassAsync("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptImportTableView",null);
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView",null);
					this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.executionframework.ResourceClient",null);
					this._loadClassAsync("com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.FileBrowser",null);
				}),10);
			},
			
		   /*
			* Provide access to an EditorFactory instance.
			*/
			getEditorFactory: function()
			{
				return EditorFactory;
			},
			
			initialize: function(args)
			{
				//com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ConstructionActionBarEntry.superclass.initialize.call(this, args);
                this.inherited('initialize', arguments);
				
                var tcPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE);
                var ewiPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI);
                var dpPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_DATAPOOL);
                var tscriptPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SCRIPT);
                var tsuitePerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SUITE);
				
                if (!tcPerm || tcPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelNewTestCase"), dojo.hitch(this, "_onClickNewTestCase"), false, {'subAction': "newTestCase",'tq': ""});
	                //this._addMenuEntry(Constants.getMessage("labelMyTestCase"), dojo.hitch(this, "_onClickMyTestCases"), false, {'subAction': "viewMyTestCases"});
                }
				this._addMenuEntry(Constants.getMessage("labelAllTestCase"), dojo.hitch(this, "_onClickAllTestCases"), false, {'subAction': "viewTestCases"});

                if (!tcPerm || tcPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelImportTestCase"), dojo.hitch(this, "_onClickImportTestCase"), false, {
                        'subAction': "importTestCase"
                    });
                }
//				this._addMenuEntry(Constants.getMessage("labelExportTestCase"), dojo.hitch(this, "_onClickExportTestCase"), false, {'subAction': "exportTestCase"});
				this._addMenuSeparator();
                
                if (!tscriptPerm || tscriptPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelNewTestScript"), dojo.hitch(this, "_onClickNewTestScript"), false, {'subAction': "newTestScript", 'tq': ""});
//					this._addMenuEntry(Constants.getMessage("labelMyTestScript"), dojo.hitch(this, "_onClickMyTestScripts"), false, {'subAction': "viewMyTestScripts"});
					//VS: Refer workitem 5834
//                    this._addMenuEntry(Constants.getMessage("labelAssocTestScript"), dojo.hitch(this, "_onClickAssociateTestScript"), false, {
//                        'subAction': "associateTestScript"
//                    });
                }
				this._addMenuEntry(Constants.getMessage("labelAllTestScript"), dojo.hitch(this, "_onClickAllTestScripts"), false, {'subAction': "viewTestScripts"});

                if (!tscriptPerm || tscriptPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelImportTestScript"), dojo.hitch(this, "_onClickImportTestScript"), false, {
                        'subAction': "importTestScript"
                    });
                }
//                this._addMenuEntry(Constants.getMessage("labelExportTestScript"), dojo.hitch(this, "_onClickExportTestScript"), false, {'subAction': "exportTestScript"});
				this._addMenuSeparator();
                
                if (!tsuitePerm || tsuitePerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelNewTestSuite"), dojo.hitch(this, "_onClickNewTestSuite"), false, {'subAction': "newTestSuite", 'tq': ""});
					//this._addMenuEntry(Constants.getMessage("labelMyTestSuite"), dojo.hitch(this, "_onClickMyTestSuites"), false, {'subAction': "viewMyTestSuites"});
                }
				
				this._addMenuEntry(Constants.getMessage("labelAllTestSuite"), dojo.hitch(this, "_onClickTestSuites"), false, {'subAction': "viewTestSuites"});

                this._addMenuSeparator();

                if (!ewiPerm || ewiPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelNewEWI"), dojo.hitch(this, "_onClickNewEwi"), false, {
                        'subAction': "newEwi",
                        'tq': ""
                    });
                    this._addMenuSeparator();
                }
				
                if (!dpPerm || dpPerm.create) {
                    this._addMenuEntry(Constants.getMessage("labelNewDatapool"), dojo.hitch(this, "_onClickNewDatapool"), false, {
                        'subAction': "newDatapool",
                        'tq': ""
                    });
                }
				this._addMenuEntry(Constants.getMessage("labelAllDatapool"), dojo.hitch(this, "_onClickAllDatapools"), false, {'subAction': "viewDatapools"});

				this._addMenuSeparator();
				this._addMenuEntry(Constants.getMessage("labelAllKeywords"), dojo.hitch(this, "_onClickKeywords"), false, {'subAction': "keywords"});

                if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("viewEwi", dojo.hitch(this, "viewEwi"));
					this.actionDispatcher.registerDispatchAction("viewTestScript", dojo.hitch(this, "viewTestScript"));
                    this.actionDispatcher.registerDispatchAction("copyTestScript", dojo.hitch(this, "copyTestScript"));
					this.actionDispatcher.registerDispatchAction("viewTestCase", dojo.hitch(this, "viewTestCase"));
					this.actionDispatcher.registerDispatchAction("viewTestSuite", dojo.hitch(this, "viewTestSuite"));
					this.actionDispatcher.registerDispatchAction("copyTestSuite", dojo.hitch(this, "copyTestSuite"));
                    this.actionDispatcher.registerDispatchAction("copyTestCase", dojo.hitch(this, "copyTestCase"));
					this.actionDispatcher.registerDispatchAction("viewDatapool", dojo.hitch(this, "viewDatapool"));
                }
			},
			
			_onClickNewTestCase: function()
			{
				var artifactModel = new ArtifactModel(Constants.TYPE_CASE);
				var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor({
                    parentController: this,
                    model: artifactModel                    
                });
				//editor.setArtifactModel(artifactModel);
				//editor.initialize({ parentController: this });
				var view = this._addPage( {name: Constants.getMessage("labelNewTestCase"), content: editor, closable: true});
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();	
			},
			
			_onClickMyTestCases: function()
			{
				var browserTitle = Constants.getMessage("labelTestCase") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelMyView"); 
                this._loadTestCases(Constants.getMessage("labelMyTestCase"), browserTitle, {authenticatedContributor: getAuthenticatedContributor().itemId});  			
			},
            
            _onClickAllTestCases: function()
            {
				var browserTitle = Constants.getMessage("labelTestCase") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
                this._loadTestCases(Constants.getMessage("labelAllTestCase"), browserTitle, {});			
            },            

			_loadTestCases: function(name, browserTitle, queryArgs)
            {
                queryArgs = queryArgs ? queryArgs : {};
				try{
					this._loadClassAsync("com.ibm.rational.test.lm.web.client.internal.config", null);
					this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient", null);
					this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient", null);
					this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient", null);
					//load class in Risk component
					this._loadClassAsync("com.ibm.rqm.risk.web.ui.internal.view.assessment.RiskProfileTemplateDialog", null);
					this._loadClassAsync("com.ibm.rqm.risk.web.client.internal.risk.RiskClient", null);
				}catch(e){
					console.error("failed to load files async for ExecutionPopup in CABE");
				}

                var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_CASE);

				var tableViewArgs = {
					parent: this,
                    testCases: [], 
                    queryName: name,
                    showQueryFilters: true,
                    isSingleSelect: false,
                    enableRowSelection: true,
					enableRowEditable: (!permission || permission[PermissionsClient.ACTION_EDIT])
                }

	            var list = new TestCaseTableView(tableViewArgs);

                // set the reference to the tabs container to allow checking for opened artifact editors
                list.artifactsDisplayContainer = this._contentArea;
                var pageName = name; 
				this._addPage( {name: pageName, content: list, closable: true, browserTitle:browserTitle});
            }, 
            	
            _refreshTestCaseList: function(queryArgs, tableView) {
                var self = this;
                var handler = {
                    success: function(cases) {
                        if (tableView) {
                            tableView.refresh(cases ? cases : []);
                        }
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                
                var responseHandler = new TestCaseMapper(handler, "success", "error");          
                TestCaseClient.getTestCasesSummary(responseHandler, queryArgs);                   
            },

			_onClickImportTestCase: function()
			{
                var importer = new com.ibm.asq.common.web.ui.internal.widgets.jrs.Uploader({
					title: Constants.getMessage("labelImportTestCase"),
					artifactType: "testcase",
                    importPrompt: Constants.getMessage("msgImportTestCase"),
                    contextHelpId: "rqm_import_test_case.html",
                    cshelpLabel: Constants.getMessage("labelImportTestCaseHelp")
				});
				
				importer._header.setCSHelpButtonLabel(Constants.getMessage("labelImportTestCaseHelp"));
				var browserTitle = Constants.getMessage("labelTestCase") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelImport");
				this._addPage( {name: Constants.getMessage("labelImportTestCase"), content: importer, closable: true, browserTitle:browserTitle});			},
			
			_onClickExportTestCase: function()
			{
				var browserTitle = Constants.getMessage("labelTestCase") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelExport");
				this._addPage( {name: Constants.getMessage("labelExportTestCase"), content: "Todo: implement export test case.", closable: true, browserTitle:browserTitle});
			},
			
			_onClickNewTestScript: function()
			{
				this._loadClassAsync("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient", null);
				var artifactModel = new ArtifactModel(Constants.TYPE_SCRIPT);
				var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor();
				editor.setArtifactModel(artifactModel);
				editor.initialize({ parentController: this });
				var view = this._addPage( {name: Constants.getMessage("labelNewTestScript"), content: editor, closable: true});
				var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();
			},

//			_onClickAssociateTestScript: function()
//			{
//				this._addPage( {name: Constants.getMessage("labelAssocTestScript"), content: "Todo: implement associate test script.", closable: true});
//			},
//			
			_onClickMyTestScripts: function()
			{
				var browserTitle = Constants.getMessage("labelTestScript") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelMyView");
                this._loadTestScripts(Constants.getMessage("labelMyTestScript"), browserTitle, {originator: getAuthenticatedContributor().itemId}); 
			},
            
            _onClickAllTestScripts: function()
            {
				var browserTitle = Constants.getMessage("labelTestScript") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
				this._loadTestScripts(Constants.getMessage("labelAllTestScript"), browserTitle, {}); 
            },           
            
			_loadTestScripts: function(name, browserTitle, queryArgs)
            {
                queryArgs = queryArgs ? queryArgs : {};
				//This client needs to be loaded before showing table, useful while delete remote scripts
				this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient", null);
				queryArgs = queryArgs ? queryArgs : {};		
				

				
                var args = {
                    scripts: [], 
                    showQueryFilters: true,
                    queryName: name               
                }			
         		var list = new TestScriptTableView(args);
                
                // NOT USED at this point. No bulk change support in test script.
				//this._testScriptTableView = list;

                // set the reference to the tabs container to allow checking for opened artifact editors
                list.artifactsDisplayContainer = this._contentArea;
				this._addPage( {name: name, content: list, closable: true, browserTitle:browserTitle});
				/*
				this._started = new Date();				
                var self = this;
                var handler = {
                    success: function(cases) {
						console.debug(self.declaredClass + ":_loadTestScripts: getTestScriptsSummary returned to handler in [" + (new Date() - self._started) + " ms]");
						list.refresh(cases ? cases : []);
						console.debug(self.declaredClass + ":_loadTestScripts: getTestScriptsSummary refreshed table in [" + (new Date() - self._started) + " ms]");
						list.stopInProgress();
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                console.debug(this.declaredClass + ": begin getTestScriptsSummary call @ " + this._started);
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
                TestScriptClient.getTestScriptsSummary(responseHandler, queryArgs);	
                */		             
            },             

			_TestScriptHeaderColumnActionInvoked: function(tableViewer, columnIndex, actionId){
				alert("test script");	
			},
			
            
            // NOT USED at this point. No bulk change support in test script.
            _handleScriptBulkChanged: function(args){
                var tsTV = this._testScriptTableView;
				var self = this;
                var handler = {
                    success: function(scripts) {
                        if (tsTV.refreshCallback && dojo.isFunction(tsTV.refreshCallback)){
                            tsTV.refreshCallback(tsTV);
                        }
						
						if (tsTV.bulkchangeActionNode){
                            tsTV.bulkchangeActionNode.setDisabled(true);
                        }
						
						if (tsTV.deleteActionNode){
                            tsTV.deleteActionNode.setDisabled(true);
                        }
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }

                var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
                TestScriptClient.postBulkChangeTestScript(responseHandler, args); 
            },
			
            _refreshTestScriptList: function(queryArgs, tableView) {
                var self = this;
                var handler = {
                    success: function(scripts) {
                        if (tableView && scripts) {
                            tableView.refresh(scripts);
                        }
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");
                TestScriptClient.getTestScriptsSummary(responseHandler, queryArgs);                 
            }, 
						
			_onClickImportTestScript: function()
			{
				// load async
				jazz.core.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.common.ImportScriptWizardPage", dojo.hitch(this, "_loadImportScript"));
			},
			
			_loadImportScript: function()
			{
				var _importWizard = new com.ibm.rqm.execution.web.ui.internal.view.common.ImportScriptWizardPage()
				var browserTitle = Constants.getMessage("labelTestScript") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelImport");
				this._addPage( {name: Constants.getMessage("labelImportTestScript"), content: _importWizard, closable: true, browserTitle:browserTitle});
			},
			
			_onClickExportTestScript: function()
			{
				var browserTitle = Constants.getMessage("labelTestScript") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelExport");
				this._addPage( {name: Constants.getMessage("labelExportTestScript"), content: "Todo: implement export test script.", closable: true, browserTitle:browserTitle});
			},
			
			_onClickNewEwi: function()
			{
				jazz.core.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem", dojo.hitch(this, "_loadNewEwi"));
			},
			
			_loadNewEwi: function()
			{
				var editor = new com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem({parentController: this});
				var browserTitle = Constants.getMessage("labelEWI") + Constants.getMessage("labelColen") +" "+ Constants.getMessage("labelCapitalNew");
				var page = this._addPage( {name: Constants.getMessage("labelNewEWI"), content: editor, closable: true, browserTitle: browserTitle});
				editor.page = page;				
				editor._updateBrowserTitle(); 
				page.controlButton.containerNode.className = "ewi-icon-16-inTab";
			},
			
			viewEwi: function(kwArgs){
				var self = this;
				var func = function() {
					var callbackObj = {
						success: function(ewis){
							if(ewis && ewis.length > 1){
								self._loadEWIError(new Error(Constants.getMessage("errRetrieveEWI")));
                    			return;
							}else{
								if(dojo.isArray(ewis))
									self._openEWI(ewis[0]);
								else
									self._openEWI(ewis);	
							}
						},
						failure: function(e){
							self._loadEWIError(e)
						}
					}
					
					var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");          
	                com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient.getExecutionWorkItemDTOs(responseHandler, kwArgs);             
                };
				jazz.core.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient", func);
			},
			
			_openEWI: function(ewiObj){
				var func = function() {
					var editor =new com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem({parentController: this, ewi: ewiObj});
					var ewiName = ewiObj.name ? ewiObj.name:"";
					var page =this._addPage({name: ewiName, content: editor, closable: true});
					page.controlButton.containerNode.className = "ewi-icon-16-inTab";
                };
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.execution.CreateExecutionWorkItem";
                this._loadClassAsync(classname, func);
			},
			
			_loadEWIError: function(e) {
                CommonUtility.handleArtifactLoadError(Constants.getMessage("labelEWI"), e.message);
            },
			
			_onClickNewDatapool: function()
			{
				jazz.core.loader.load_async("com.ibm.rqm.datapool.web.ui.internal.view.datapool.DatapoolEditor", dojo.hitch(this, "_loadNewDatapool"));
			},
			
			_loadNewDatapool: function() {
				var artifactModel = new ArtifactModel(Constants.TYPE_DATAPOOL);
				var editor = new com.ibm.rqm.datapool.web.ui.internal.view.datapool.DatapoolEditor();
				editor.setArtifactModel(artifactModel);
				editor.initialize({ parentController: this });
				var view = this._addPage( {name: Constants.getMessage("labelNewDatapool"), content: editor, closable: true});
				var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();
			},
			
			_onClickAllDatapools: function()
            {
				jazz.core.loader.load_async("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient", function(){});
                jazz.core.loader.load_async("com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableView", dojo.hitch(this, "_loadDatapools", Constants.getMessage("labelAllDatapool")));
            },            

            _loadDatapools: function(name)
            {
                var queryArgs = {};
				var actions = [];
        		actions.push({
                    id: "refresh",
            		label: Constants.getMessage("labelRefresh"),
            		actionHandler: dojo.hitch(this, "_refreshDatapoolList"),
            		iconClass: "refresh-icon-image",
            		disabledOnReadOnly: true
        		});
                var tableViewArgs = {
					queryName: name,
                    datapools: [],
                    showInitLoadProgress: true,
					actions: actions
                }
	            var list = new com.ibm.rqm.datapool.web.ui.internal.view.table.DatapoolTableView(tableViewArgs);
				list.artifactsDisplayContainer = this._contentArea;
				var browserTitle = Constants.getMessage("labelDatapool") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
				this._addPage( {name: name, content: list, closable: true, browserTitle: browserTitle});
            }, 
			
			_refreshDatapoolList: function(tableView){
            	var self = this;
            	var handler = {
                	success: function(datapools){
                    	if (tableView) {
                        	tableView.refresh(datapools);
                    	}
                	},
                	error: function(e){
                    	self._error(e);
                	}
           		}
            
           		var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            	com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient.getDatapoolDTOs(responseHandler, {});
        	},
			
			viewDatapool: function(kwArgs) {
				jazz.core.loader.load_async("com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient", function(){});
                jazz.core.loader.load_async("com.ibm.rqm.datapool.web.ui.internal.view.datapool.DatapoolEditor", dojo.hitch(this, "_loadDatapool", kwArgs.itemId));
			},
			
			_onClickNewTestSuite:function()
			{
				var artifactModel = new ArtifactModel(Constants.TYPE_SUITE);
				var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor();
				editor.setArtifactModel(artifactModel);
				editor.initialize({ parentController: this });
				var view = this._addPage( {name: Constants.getMessage("labelNewTestSuite"), content: editor, closable: true});
				var controller = new ArtifactEditorPageController(artifactModel, view);
				controller.updateTab();
			},
			
            _onClickTestSuites: function() {
				var self = this;
				var func = function() {
					var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_SUITE);
					var tableViewArgs = {
						parent: self,
						suites: [],
						queryName: Constants.getMessage("labelAllTestSuite"),
						showQueryFilters: true,
						enableRowEditable: (!permission || permission[PermissionsClient.ACTION_EDIT]),
						//refreshCallback: dojo.hitch(this, "_refreshTestSuiteList", queryArgs),
						enableRowEditable: !permission || permission[PermissionsClient.ACTION_EDIT]
					}
					
					var list = new com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView(tableViewArgs);
					self._testSuiteTableView = list;
					self._addPage({name: tableViewArgs.queryName,
						content: list,
						closable: true,
						browserTitle: Constants.getMessage("labelTestSuite") + Constants.getMessage("labelColen") + " " + Constants.getMessage("labelAllTestSuite")
					});
				}
				
                var classname = "com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTableView";
                if (dojo.getObject(classname) == null) {
					self._loadClassAsync(classname, func);
				} else {
					func();
				}
			},
			
			_refreshTestSuiteList: function(queryArgs, tableView){
				this._loadClassAsync("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient", null);
				var self = this;
                var handler = {
                    success: function(suites) {
                        if (tableView && suites) {
                            tableView.refresh(suites);
                        }
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                var responseHandler = new com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper(handler, "success", "error");
                com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.getTestExecutionSuiteSummaryDTOs(responseHandler, queryArgs);
			},
			
			_loadDatapool: function(itemId)
            {
            	// create the editor to show loading in progress in a new tab and reinitialize the editor
            	// after the data is fetched from the server
                var artifactModel = new ArtifactModel(Constants.TYPE_DATAPOOL);
                var editor = new com.ibm.rqm.datapool.web.ui.internal.view.datapool.DatapoolEditor();
                editor.setArtifactModel(artifactModel);
//                editor.initialize({ parentController: this });
                var view = this._addPage( {name: Constants.getMessage("labelLoading"), content: editor, closable: true});
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();

                var queryArgs = {itemId:itemId};
                var self = this;
                var handler = {
                    success: function(datapools) {
                        if (datapools !=null  && datapools.length > 0) {
                            self._showDatapool(datapools[0], editor);
                        } else {
                            self._loadDatapoolError(new Error(Constants.getMessage("errDatapoolNotFound")));
                        }
                    },
                    error: function(e) {
                        self._loadDatapoolError(e);
                    }
                }
                
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
                com.ibm.rqm.datapool.web.client.internal.datapool.DatapoolClient.getDatapoolDTOs(responseHandler, queryArgs);             
            }, 
            
			_showDatapool: function(datapool, editor)
			{
                // initialize will implicitly update the tab button label
				editor.initialize({ parentController: this, datapool: datapool });
			},
            
            _loadDatapoolError: function(e) {
                CommonUtility.handleArtifactLoadError(Constants.getMessage("labelDatapool"), e.message);
            },
            
			_onClickKeywords:function()
			{
				this._loadClassAsync("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient", null);
				this._loadClassAsync("com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordList", dojo.hitch(this, "_viewKeywords"));
			},
			_viewKeywords:function()
			{
				var keywordTable = new com.ibm.rqm.keyword.web.ui.internal.view.keyword.KeywordList();
				var browserTitle = Constants.getMessage("labelKeywords") + Constants.getMessage("labelColen") +" " + Constants.getMessage("labelAllView");
				this._addPage( {name: Constants.getMessage("labelAllKeywords"), content: keywordTable, closable: true,browserTitle: browserTitle});				

			},
            viewTestScript: function(kwArgs) 
            {
                // create the editor to show loading in progress in a new tab and reinitialize the editor
            	// after the data is fetched from the server
                var artifactModel = new ArtifactModel(Constants.TYPE_SCRIPT);
                var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor();
                editor.setArtifactModel(artifactModel);
//				editor._isSnapshot = true;
//                editor.initialize({parentController: this});
                var view = this._addPage( {name:Constants.getMessage("labelLoading"), content: editor, closable: true});
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();

                var self = this;
                var handler = {
                    success: function(result) {
                        self._doViewTestScript(result, editor);
                    },
                    error: function(e) {
                        self._loadTestScriptError(e);
                    }
                }

				this._loadClassAsync("com.ibm.rqm.keyword.web.client.internal.keyword.KeywordClient", null);  
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");
				if (null != kwArgs.uid && null != kwArgs.revision) {
					TestScriptClient.getTestScriptRevision(responseHandler, kwArgs.uid, kwArgs.revision);
				} else {      
                	TestScriptClient.getTestScript(responseHandler, kwArgs.id);
				}
            },
            
            _doViewTestScript: function(result, editor) 
            {
				if (!result || result.length != 1)
                {
                    this._loadTestScriptError(new Error(Constants.getMessage("errTestScriptNotFound")));
                    return;
                }
				if ( dojo.isArray(result) ) 
                {
                    result = result[0]; 
                }
                // initialize will implicitly update the tab button label
                editor.initialize({parentController: this, testScript: result});
            },
            
            _loadTestScriptError: function(e) {
                CommonUtility.handleArtifactLoadError(Constants.getMessage("labelTestScript"), e.message);
            },
            
			viewTestCase: function(kwArgs)
            {			
				var artifactModel = new ArtifactModel(Constants.TYPE_CASE);
                var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor({
                    parentController: this,
                    model: artifactModel,
                    kwArgs: kwArgs
                });
				//editor.setArtifactModel(artifactModel);
                //editor.initialize({ parentController: this, testCase: result});
                var view = this._addPage( {name: Constants.getMessage("labelLoading"), content: editor, closable: true});
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();			
            },
			
            copyTestCase: function(kwArgs)
            {              
                var artifactModel = new ArtifactModel(Constants.TYPE_CASE);
                var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestCaseEditor({
                    parentController: this,
                    model: artifactModel,
                    copy: true,
                    kwArgs: kwArgs                  
                });
                //editor.setArtifactModel(artifactModel);
                //editor.initialize({ parentController: this, testCase: resul, copy: true });
                var view = this._addPage({name: Constants.getMessage("labelLoading"), content: editor, closable: true});
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();
            },			

			viewTestSuite: function(kwArgs) {
                var artifactModel = new ArtifactModel(Constants.TYPE_SUITE);
                var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor();
                editor.setArtifactModel(artifactModel);
//                editor.initialize({ parentController: this });
                var view = this._addPage( {name: Constants.getMessage("labelLoading"), content: editor, closable: true});
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();

				var self = this;
				var func = function() {
					var callbackObj = {
						success: function(suite){
                            if (suite.length > 0) {
                                self._doViewTestSuite(suite[0], editor, kwArgs);
                            } else {
                                self._loadTestSuiteError(new Error(Constants.getMessage("errTestSuiteNotFound")));
                            }
						},
						failure: function(errorObj){
							self._loadTestSuiteError(errorObj);
						}
					}
					var responseHandler = new com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper(callbackObj, "success", "failure");
					if (null != kwArgs.uid && null != kwArgs.revision) {
						com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.getTestExecutionSuiteRevision(responseHandler, kwArgs.uid, kwArgs.revision);
					} else { 
						com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.getTestExecutionSuiteDTOs(responseHandler, 
							{id: kwArgs.id, 
							resolveWorkItems: true, 
							resolveElements: true,
							resolveElementFullTestase: false, 
							resolveElementsTestcase: true,
							resolveElementsRequest: false,
							resolveElementsResult: false,
							resolveFullCurrentResult: false,
							resolveCurrentResultElements: false,
							resolveFlattenedTestCase: true,
							resolvePlan: false,
							resolveMinimalPlan: true, 
							resolveSection: true,
							resolveCategory: true
						});
					}
					
                };
                //Load both Mapper and client before calling
				var loadClient = function(){
					var cn = "com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient";
                	self._loadClassAsync(cn, func);
				};
                var classname = "com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper";
                this._loadClassAsync(classname, loadClient);
			},

			copyTestSuite: function(kwArgs){
				var artifactModel = new ArtifactModel(Constants.TYPE_SUITE);
                var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestSuiteEditor({
					parentController: this,
                		model: artifactModel,
                		copy: true,
                		kwArgs: kwArgs                  
				});
				editor.setArtifactModel(artifactModel);
                var view = this._addPage( {name:Constants.getMessage("labelLoading"), content: editor, closable: true});
                var controller = new ArtifactEditorPageController(artifactModel, view);
                controller.updateTab();
                
				
                var self = this;
                var revision = kwArgs.revision;
				var snapshotName = kwArgs.snapshotName;
                var handler = {
                    success: function(suite) {
						if (suite.length > 0) {
							self._doViewTestSuite(suite[0], editor, kwArgs);
						}
						else {
							self._loadTestSuiteError(new Error(Constants.getMessage("errTestSuiteNotFound")));
						}
                    },
                    error: function(errorObj) {
                        self._loadTestSuiteError(errorObj);
                    }
                }
                var queryArgs = { revision: kwArgs.revision, itemId: kwArgs.uid};
				var responseHandler = new com.ibm.rqm.execution.web.client.internal.mapper.TestExecutionSuiteMapper(handler, "success", "error");
				com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient.getTestExecutionSuiteDTOs(responseHandler, queryArgs);			             
			},

			_doViewTestSuite: function(testSuite, editor, args){
				editor.initialize({ parentController: this, testSuite: testSuite });
			},
			
            _loadTestSuiteError: function(e) {
                CommonUtility.handleArtifactLoadError(Constants.getMessage("labelTestSuite"), e.message);
            },
			
			copyTestScript: function(kwArgs){
				var artifactModel = new ArtifactModel(Constants.TYPE_SCRIPT);
	                var editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor({
						parentController: this,
                    		model: artifactModel,
                    		copy: true,
                    		kwArgs: kwArgs                  
					});

	                var view = this._addPage( {name:Constants.getMessage("labelLoading"), content: editor, closable: true});
	                var controller = new ArtifactEditorPageController(artifactModel, view);
	                controller.updateTab();
	                
					
	                var self = this;
	                var revision = kwArgs.revision;
					var snapshotName = kwArgs.snapshotName;
	                var handler = {
	                    success: function(result) {
							self._doViewTestScript(result, editor);
	                    },
	                    error: function(e) {
	                        self._loadTestScriptError(e);
	                    }
	                }
	                var queryArgs = { revision: kwArgs.revision, itemId: kwArgs.uid};
	                var responseHandler = new ServiceResponseHandler(handler, "success", "error");
					TestScriptClient.getTestScripts(responseHandler, queryArgs);			             
			},

			_error: function(error) 
			{
				console.debug("ConstructionActionBarEntry: Error invoking service; message: " + error.message);
			}
		}
	);
}
)();
